'use strict';var juju={components:{}};describe('UserProfileModelList',function(){var models=void 0,user=void 0;beforeAll(function(done){YUI().use('user-profile-model-list',function(){done();});});beforeEach(function(){models=[{uuid:'model1',name:'spinach/sandbox',lastConnection:'2016-09-12T15:42:09Z',ownerTag:'user-who',owner:'who',isAlive:true}];user={user:'user-who',usernameDisplay:'test owner'};});it('renders the empty state',function(){var acl={canAddModels:function canAddModels(){return true;}};var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{acl:acl,currentModel:'model1',listModelsWithInfo:sinon.stub().callsArgWith(0,null,[]),switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();var output=component.getRenderOutput();var expected=React.createElement('div',{className:'user-profile__model-list'},React.createElement('div',{className:'user-profile__header twelve-col no-margin-bottom'},'Models',React.createElement('span',{className:'user-profile__size'},'(',0,')'),React.createElement(juju.components.CreateModelButton,{switchModel:instance.switchModel})),undefined);assert.deepEqual(output,expected);});it('displays loading spinner when loading',function(){var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{currentModel:'model1',listModelsWithInfo:sinon.stub(),switchModel:sinon.stub(),user:user}),true);var output=component.getRenderOutput();assert.deepEqual(output,React.createElement('div',{className:'user-profile__model-list twelve-col'},React.createElement(juju.components.Spinner,null)));});it('renders a list of models',function(){var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var acl={canAddModels:function canAddModels(){return true;}};var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{acl:acl,currentModel:'model1',listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();var output=component.getRenderOutput();var expected=React.createElement('div',{className:'user-profile__model-list'},React.createElement('div',{className:'user-profile__header twelve-col no-margin-bottom'},'Models',React.createElement('span',{className:'user-profile__size'},'(',1,')'),React.createElement(juju.components.CreateModelButton,{switchModel:instance.switchModel})),React.createElement('ul',{className:'user-profile__list twelve-col'},React.createElement('li',{className:'user-profile__list-header twelve-col'},React.createElement('span',{className:'user-profile__list-col three-col'},'Name'),React.createElement('span',{className:'user-profile__list-col four-col'},'Credential'),React.createElement('span',{className:'user-profile__list-col two-col'},'Last accessed'),React.createElement('span',{className:'user-profile__list-col one-col'},'Units'),React.createElement('span',{className:'user-profile__list-col two-col last-col'},'Owner')),[React.createElement(juju.components.UserProfileEntity,{entity:models[0],expanded:true,key:'model1',switchModel:instance.switchModel,type:'model'},React.createElement('span',{className:'user-profile__list-col three-col'},'spinach/sandbox'),React.createElement('span',{className:'user-profile__list-col four-col'},'--'),React.createElement('span',{className:'user-profile__list-col two-col'},React.createElement(juju.components.DateDisplay,{date:'2016-09-12T15:42:09Z',relative:true})),React.createElement('span',{className:'user-profile__list-col one-col'},'--'),React.createElement('span',{className:'user-profile__list-col two-col last-col'},'who'))]));assert.deepEqual(output,expected);});it('can render models that are being destroyed',function(){models[0].isAlive=false;var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{currentModel:'model1',listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var output=component.getRenderOutput();var content=output.props.children[1].props.children[1][0];var expected=React.createElement('li',{className:'user-profile__entity user-profile__list-row',key:'model1'},'spinach/sandbox',' is being destroyed.');assert.deepEqual(content,expected);});it('switches models when calling switchModel method passed to list',function(){var switchModel=sinon.stub();var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{currentModel:'model1',listModelsWithInfo:listModelsWithInfo,switchModel:switchModel,user:user}),true);var instance=component.getMountedInstance();instance.switchModel('abc123','modelname');assert.equal(switchModel.callCount,1,'switchModel not called');assert.deepEqual(switchModel.args[0],['abc123',[{uuid:'model1',name:'spinach/sandbox',lastConnection:'2016-09-12T15:42:09Z',ownerTag:'user-who',owner:'who',isAlive:true}],'modelname',undefined]);});it('can reset the model connection',function(){var utilsSwitchModel=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{listModelsWithInfo:sinon.stub(),switchModel:utilsSwitchModel,user:user}),true);var instance=renderer.getMountedInstance();instance.switchModel();assert.equal(utilsSwitchModel.callCount,1,'Model disconnect not called');var switchArgs=utilsSwitchModel.args[0];assert.equal(switchArgs[0],undefined,'UUID should not be defined');});it('will abort the requests when unmounting',function(){var listModelsWithInfoAbort=sinon.stub();var listModelsWithInfo=sinon.stub().returns({abort:listModelsWithInfoAbort});var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{currentModel:'model1',listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);renderer.unmount();assert.equal(listModelsWithInfoAbort.callCount,1);});it('broadcasts starting status',function(){var broadcastStatus=sinon.stub();jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{broadcastStatus:broadcastStatus,currentModel:'model1',listModelsWithInfo:sinon.stub(),switchModel:sinon.stub(),user:user}),true);assert.equal(broadcastStatus.args[0][0],'starting');});it('broadcasts ok status',function(){var broadcastStatus=sinon.stub();jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{broadcastStatus:broadcastStatus,currentModel:'model1',listModelsWithInfo:sinon.stub().callsArgWith(0,null,models),switchModel:sinon.stub(),user:user}),true);assert.equal(broadcastStatus.args[1][0],'ok');});it('broadcasts empty status',function(){var broadcastStatus=sinon.stub();jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{broadcastStatus:broadcastStatus,currentModel:'model1',listModelsWithInfo:sinon.stub().callsArgWith(0,null,[]),switchModel:sinon.stub(),user:user}),true);assert.equal(broadcastStatus.args[1][0],'empty');});it('broadcasts error status',function(){var broadcastStatus=sinon.stub();jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{broadcastStatus:broadcastStatus,currentModel:'model1',listModelsWithInfo:sinon.stub().callsArgWith(0,'bad wolf',[]),switchModel:sinon.stub(),user:user}),true);assert.equal(broadcastStatus.args[1][0],'error');});});