'use strict';YUI.add('juju-env-bakery',function(Y){var module=Y.namespace('juju.environments.web');var macaroon=Y.namespace('macaroon');var DISCHARGE_TOKEN='discharge-token';var Bakery=Y.Base.create('Bakery',Y.Base,[],{initializer:function initializer(cfg){this.webhandler=cfg.webhandler;if(cfg.visitMethod){this.visitMethod=cfg.visitMethod;}else if(cfg.interactive!==undefined&&!cfg.interactive){this.visitMethod=this._nonInteractiveVisitMethod;}else{this.visitMethod=this._defaultVisitMethod;}if(cfg.existingCookie){this.macaroonName=cfg.existingCookie;}else{this.macaroonName='Macaroons-'+cfg.serviceName;}this.staticMacaroonPath=cfg.staticMacaroonPath;this.setCookiePath=cfg.setCookiePath;this.nonceLen=24;this.cookieStore=cfg.cookieStore;if(cfg.macaroon){if(this.cookieStore){this.cookieStore.setItem(this.macaroonName,cfg.macaroon);}else{var prefix=this.macaroonName+'=';document.cookie=prefix+cfg.macaroon+';path=/';}}this.dischargeStore=cfg.dischargeStore;if(!this.dischargeStore){console.error('bakery instantiated without a discharge store');return;}if(cfg.dischargeToken){this.dischargeStore.setItem(DISCHARGE_TOKEN,cfg.dischargeToken);}},fetchMacaroonFromStaticPath:function fetchMacaroonFromStaticPath(callback){var savedMacaroon=this.getMacaroon();if(savedMacaroon!==null){callback(null,savedMacaroon);return;}if(!this.staticMacaroonPath){callback('Static macaroon path was not defined.');return;}return this.webhandler.sendGetRequest(this.staticMacaroonPath,null,null,null,false,null,this._interactivePrefetch.bind(this,callback));},_interactivePrefetch:function _interactivePrefetch(callback,res){var macaroon={};try{macaroon=JSON.parse(res.target.responseText);}catch(e){callback(e);return;}this._authenticate(macaroon,function(){callback(null,this.getMacaroon());}.bind(this),callback);},sendGetRequest:function sendGetRequest(path,successCallback,failureCallback,redirect){var macaroons=this.getMacaroon();var headers={'Bakery-Protocol-Version':1};if(macaroons!==null){headers['Macaroons']=macaroons;}return this.webhandler.sendGetRequest(path,headers,null,null,false,null,this._requestHandlerWithInteraction.bind(this,path,successCallback,failureCallback,redirect));},sendDeleteRequest:function sendDeleteRequest(path,successCallback,failureCallback,redirect){var macaroons=this.getMacaroon();var headers={'Bakery-Protocol-Version':1};if(macaroons!==null){headers['Macaroons']=macaroons;}return this.webhandler.sendDeleteRequest(path,headers,null,null,false,null,this._requestHandlerWithInteraction.bind(this,path,successCallback,failureCallback,redirect));},sendPostRequest:function sendPostRequest(path,data,successCallback,failureCallback,redirect){var macaroons=this.getMacaroon();var headers={'Bakery-Protocol-Version':1,'Content-type':'application/json'};if(macaroons!==null){headers['Macaroons']=macaroons;}return this.webhandler.sendPostRequest(path,headers,data,null,null,false,null,this._requestHandlerWithInteraction.bind(this,path,successCallback,failureCallback,redirect));},sendPutRequest:function sendPutRequest(path,data,successCallback,failureCallback,redirect){var macaroons=this.getMacaroon();var headers={'Bakery-Protocol-Version':1,'Content-type':'application/json'};if(macaroons!==null){headers['Macaroons']=macaroons;}return this.webhandler.sendPutRequest(path,headers,data,null,null,false,null,this._requestHandlerWithInteraction.bind(this,path,successCallback,failureCallback,redirect));},sendPatchRequest:function sendPatchRequest(path,data,successCallback,failureCallback,redirect){var macaroons=this.getMacaroon();var headers={'Bakery-Protocol-Version':1,'Content-type':'application/json'};if(macaroons!==null){headers.Macaroons=macaroons;}return this.webhandler.sendPatchRequest(path,headers,data,null,null,false,null,this._requestHandlerWithInteraction.bind(this,path,successCallback,failureCallback,redirect));},_requestHandlerWithInteraction:function _requestHandlerWithInteraction(path,successCallback,failureCallback){var redirect=arguments.length<=3||arguments[3]===undefined?true:arguments[3];var response=arguments[4];var target=response.target;if(target.status===401&&target.getResponseHeader('Www-Authenticate')==='Macaroon'&&redirect===true){var jsonResponse=JSON.parse(target.responseText);this._authenticate(jsonResponse.Info.Macaroon,this._sendOriginalRequest.bind(this,path,successCallback,failureCallback),failureCallback);}else{this._requestHandler(successCallback,failureCallback,response);}},_requestHandler:function _requestHandler(successCallback,failureCallback,response){var target=response.target;if(target.status>=400){failureCallback(response);return;}successCallback(response);},_sendOriginalRequest:function _sendOriginalRequest(path,successCallback,failureCallback){var macaroons=this.getMacaroon();var headers={'Bakery-Protocol-Version':1};if(macaroons!==null){headers['Macaroons']=macaroons;}return this.webhandler.sendGetRequest(path,headers,null,null,false,null,this._requestHandler.bind(this,successCallback,failureCallback));},_authenticate:function _authenticate(m,requestFunc,failureCallback){var successCallback=this._processDischarges.bind(this,requestFunc,failureCallback);this.discharge(m,successCallback,failureCallback);},discharge:function discharge(m,successCallback,failureCallback){try{macaroon.discharge(macaroon.import(m),this._obtainThirdPartyDischarge.bind(this),function(discharges){successCallback(macaroon.export(discharges));},failureCallback);}catch(exc){failureCallback(exc.message);}},_processDischarges:function _processDischarges(requestFunc,failureCallback,macaroons){var content=JSON.stringify({'Macaroons':macaroons});if(this.setCookiePath===undefined){this._successfulDischarges(requestFunc,macaroons);return;}return this.webhandler.sendPutRequest(this.setCookiePath,null,content,null,null,true,null,this._requestHandler.bind(this,this._successfulDischarges.bind(this,requestFunc,macaroons),failureCallback));},_successfulDischarges:function _successfulDischarges(originalRequest,jsonMacaroon){if(this.cookieStore){this.cookieStore.setItem(this.macaroonName,btoa(JSON.stringify(jsonMacaroon)));}else{var prefix=this.macaroonName+'=';document.cookie=prefix+btoa(JSON.stringify(jsonMacaroon))+';path=/';}originalRequest();},_obtainThirdPartyDischarge:function _obtainThirdPartyDischarge(location,thirdPartyLocation,condition,successCallback,failureCallback){thirdPartyLocation+='/discharge';var dischargeToken=this.dischargeStore.getItem(DISCHARGE_TOKEN);var headers={'Bakery-Protocol-Version':1,'Content-Type':'application/x-www-form-urlencoded'};if(dischargeToken){headers['Macaroons']=dischargeToken;}var content='id='+encodeURIComponent(condition)+'&location='+encodeURIComponent(location);return this.webhandler.sendPostRequest(thirdPartyLocation,headers,content,null,null,false,null,this._requestHandler.bind(this,this._exportMacaroon.bind(this,successCallback,failureCallback),this._interact.bind(this,successCallback,failureCallback)));},_exportMacaroon:function _exportMacaroon(successCallback,failureCallback,response){try{var json=JSON.parse(response.target.responseText);if(json.DischargeToken!==undefined&&json.DischargeToken!==''){this.dischargeStore.setItem(DISCHARGE_TOKEN,btoa(JSON.stringify(json.DischargeToken)));}successCallback(macaroon.import(json.Macaroon));}catch(ex){failureCallback(ex.message);}},_interact:function _interact(successCallback,failureCallback,e){var response=JSON.parse(e.target.responseText);if(response.Code!=='interaction required'){failureCallback(response.Code);return;}this.visitMethod(response);return this.webhandler.sendGetRequest(response.Info.WaitURL,null,null,null,false,null,this._requestHandler.bind(this,this._exportMacaroon.bind(this,successCallback,failureCallback),failureCallback));},_nonInteractiveVisitMethod:function _nonInteractiveVisitMethod(response){var acceptHeaders={'Accept':'application/json'};var contentHeaders={'Content-Type':'application/json'};var login=function login(response){var method=JSON.parse(response.target.responseText).jujugui;var data=JSON.stringify({login:window.juju_config.auth});return this.webhandler.sendPostRequest(method,contentHeaders,data,null,null,false,null,null);};return this.webhandler.sendGetRequest(response.Info.VisitURL,acceptHeaders,null,null,false,null,login.bind(this));},addThirdPartyCaveat:function addThirdPartyCaveat(m,condition,location,thirdPartyPublicKey,myKeyPair){var nonce=nacl.randomBytes(this.nonceLen);var rootKey=nacl.randomBytes(this.nonceLen);var plain=JSON.stringify({RootKey:nacl.util.encodeBase64(rootKey),Condition:condition});var sealed=nacl.box(nacl.util.decodeUTF8(plain),nonce,thirdPartyPublicKey,myKeyPair.secretKey);var caveatIdObj={ThirdPartyPublicKey:nacl.util.encodeBase64(thirdPartyPublicKey),FirstPartyPublicKey:nacl.util.encodeBase64(myKeyPair.publicKey),Nonce:nacl.util.encodeBase64(nonce),Id:nacl.util.encodeBase64(sealed)};var caveatId=JSON.stringify(caveatIdObj);m.addThirdPartyCaveat(rootKey,caveatId,location);},dischargeThirdPartyCaveat:function dischargeThirdPartyCaveat(caveatId,myKeyPair,check){var caveatIdObj={};try{caveatIdObj=JSON.parse(caveatId);}catch(ex){throw new Exception('Unable to parse caveatId');}if(nacl.util.encodeBase64(myKeyPair.publicKey)!==caveatIdObj.ThirdPartyPublicKey){throw new Exception('public key mismatch');}var nonce=nacl.util.decodeBase64(caveatIdObj.Nonce);var firstPartyPub=nacl.util.decodeBase64(caveatIdObj.FirstPartyPublicKey);if(nonce.length!==this.nonceLen){throw new Exception('bad nonce length');}var sealed=nacl.util.decodeBase64(caveatIdObj.Id);var unsealed=nacl.box.open(sealed,nonce,firstPartyPub,myKeyPair.secretKey);var unsealedStr=nacl.util.encodeUTF8(unsealed);var plain=JSON.parse(unsealedStr);if(plain.Condition===undefined){throw new Exception('empty condition in third party caveat');}check(plain.Condition);return macaroon.newMacaroon(nacl.util.decodeBase64(plain.RootKey),caveatId,'');},_defaultVisitMethod:function _defaultVisitMethod(response){window.open(response.Info.VisitURL,'Login');},getMacaroon:function getMacaroon(){if(this.cookieStore){return this.cookieStore.getItem(this.macaroonName);}else{var name=this.macaroonName+'=',macaroon=null;document.cookie.split(';').some(function(cookie){cookie=cookie.trim();if(cookie.indexOf(name)===0){macaroon=cookie.substring(name.length,cookie.length);return true;}return false;});return macaroon;}},clearCookie:function clearCookie(){var name=this.macaroonName;var pathParts='/profile'.split('/');var currentPath=' path=';document.cookie=name+'=; expires=Thu, 01-Jan-1970 00:00:01 GMT;';pathParts.forEach(function(part){currentPath+=(currentPath.substr(-1)!=='/'?'/':'')+part;document.cookie=name+'=; expires=Thu, 01-Jan-1970 00:00:01 GMT;'+currentPath+';';});}});module.Bakery=Bakery;},'0.1.0',{requires:['base','cookie','node','juju-env-base','juju-env-web-handler','macaroon']});